import { StorageStatisticsSegmentDto } from "@upload-io/upload-shared-iso";
import { StorageStatisticsSegmentUnboxedDto } from "@upload-io/upload-shared-iso/statistics/storage/dtos/shared/StorageStatisticsSegmentDto";

export interface StorageStatisticsBySourceDto {
  dashboard: StorageStatisticsSegmentDto;
  other: StorageStatisticsSegmentDto;
}

export interface StorageStatisticsBySourceUnboxedDto {
  dashboard: StorageStatisticsSegmentUnboxedDto;
  other: StorageStatisticsSegmentUnboxedDto;
}

export namespace StorageStatisticsBySourceDto {
  export const empty: StorageStatisticsBySourceDto = {
    dashboard: StorageStatisticsSegmentDto.empty,
    other: StorageStatisticsSegmentDto.empty
  };

  export function combine(
    left: StorageStatisticsBySourceDto,
    right: StorageStatisticsBySourceDto
  ): StorageStatisticsBySourceDto {
    return {
      dashboard: StorageStatisticsSegmentDto.combine(left.dashboard, right.dashboard),
      other: StorageStatisticsSegmentDto.combine(left.other, right.other)
    };
  }
}
